#define _GNU_SOURCE // necesario para strcasestr()

#include <stdio.h>
#include <string.h>
#include "listas.h"

struct alumno *buscarporlegajo(struct alumno **H) {
	struct alumno *q;
	int legajo;
	
	printf("Ingrese numero de legajo: ");
	scanf("%d", &legajo);
	
	q = *H;
	while(q) {
		/* comienzo a recorrer la lista, en caso de coincida con el valor
		 * a buscar, retorno el puntero a ese nodo
		 */
		if(q->legajo == legajo) return q;
		// sino, sigo con el siguiente
		q = q->next;
	}
	// termine de recorrer la lista y no lo encontre, retorno NULL
	return NULL;
}

struct alumno *buscarpornombre(struct alumno **H) {
	struct alumno *q;
	char nombre[50];
	
	printf("Ingrese nombre: ");
	scanf("%s", nombre);
	
	q = *H;
	while(q) {
		/* en caso de campos con strings, quiero comprobar sin que importen
		 * las mayusculas
		 */
		if(!strcasestr(q->nombre, nombre)) return q;
		q = q->next;
	}
	return NULL;
}

struct alumno *buscarporapellido(struct alumno **H) {
	struct alumno *q;
	char apellido[50];
	
	printf("Ingrese apellido: ");
	scanf("%s", apellido);
	
	q = *H;
	while(q) {
		if(!strcasestr(q->apellido, apellido)) return q;
		q = q->next;
	}
	return NULL;
}

struct alumno *buscarporemail(struct alumno **H) {
	struct alumno *q;
	char email[50];
	
	printf("Ingrese email: ");
	scanf("%s", email);
	
	q = *H;
	while(q) {
		if(!strcasestr(q->email, email)) return q;
		q = q->next;
	}
	return NULL;
}

struct alumno *buscarpornota1p(struct alumno **H) {
	struct alumno *q;
	int nota;
	
	printf("Ingrese nota: ");
	scanf("%d", &nota);
	
	q = *H;
	while(q) {
		if(q->nota1p == nota) return q;
		q = q->next;
	}
	return NULL;
}

struct alumno *buscarpornota2p(struct alumno **H) {
	struct alumno *q;
	int nota;
	
	printf("Ingrese nota: ");
	scanf("%d", &nota);
	
	q = *H;
	while(q) {
		if(q->nota2p == nota) return q;
		q = q->next;
	}
	return NULL;
}

struct alumno *buscarpornotatp(struct alumno **H) {
	struct alumno *q;
	int nota;
	
	printf("Ingrese nota: ");
	scanf("%d", &nota);
	
	q = *H;
	while(q) {
		if(q->notatp == nota) return q;
		q = q->next;
	}
	return NULL;
}
