#include "listas.h"
#include <string.h>

void ordenarporlegajo(struct alumno **H) {
	int swappeada;
	struct alumno *q;
	
	do {
		swappeada = 0;
		for(q = *H; q->next != NULL; q = q->next) {
			// recorro todos los nodos
			if(q->legajo > q->next->legajo) {
				/* si el actual es mayor que el siguiente, marco que los 
				 * intercambie, y llamo a swapnodo
				 */
				swappeada = 1;
				swapnodo(q, q->next);
			}
		}
		// recorro la lista entera, hasta que no haya tenido que intercambiar
		// ningun nodo, indicando que esta ordenada.
	} while(swappeada);
}

void ordenarpornombre(struct alumno **H) {
	int swappeada;
	struct alumno *q;
	
	do {
		swappeada = 0;
		for(q = *H; q->next != NULL; q = q->next) {
			if(strcmp(q->nombre, q->next->nombre) > 0) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
		}
	} while(swappeada);
}

void ordenarporapellido(struct alumno **H) {
	int swappeada;
	struct alumno *q;
	
	do {
		swappeada = 0;
		for(q = *H; q->next != NULL; q = q->next) {
			if(strcmp(q->apellido, q->next->apellido) > 0) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
		}
	} while(swappeada);
}

void ordenarporemail(struct alumno **H) {
	int swappeada;
	struct alumno *q;
	
	do {
		swappeada = 0;
		for(q = *H; q->next != NULL; q = q->next) {
			if(strcmp(q->email, q->next->email) > 0) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
		}
	} while(swappeada);
}

void ordenarpornota1p(struct alumno **H) {
	int swappeada;
	struct alumno *q;
	
	do {
		swappeada = 0;
		for(q = *H; q->next != NULL; q = q->next) {
			if(q->nota1p > q->next->nota1p) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
		}
	} while(swappeada);
}

void ordenarpornota2p(struct alumno **H) {
	int swappeada;
	struct alumno *q;
	
	do {
		swappeada = 0;
		for(q = *H; q->next != NULL; q = q->next) {
			if(q->nota2p > q->next->nota2p) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
		}
	} while(swappeada);
}

void ordenarpornotatp(struct alumno **H) {
	int swappeada;
	struct alumno *q;
	
	do {
		swappeada = 0;
		for(q = *H; q->next != NULL; q = q->next) {
			if(q->notatp > q->next->notatp) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
		}
	} while(swappeada);
}
